using System.Numerics;
using System.Threading;

namespace FastRng.Distributions;

public interface IDistribution<TNum> where TNum : IFloatingPointIeee754<TNum>
{
    public TNum GetDistributedValue(CancellationToken token = default);
        
    public uint NextNumber(uint rangeStart, uint rangeEnd, CancellationToken cancel = default);
        
    public ulong NextNumber(ulong rangeStart, ulong rangeEnd, CancellationToken cancel = default);
        
    public TNum NextNumber(TNum rangeStart, TNum rangeEnd, CancellationToken cancel = default);
        
    public TNum NextNumber(CancellationToken cancel = default);
        
    public bool HasDecisionBeenMade(TNum above, TNum below, CancellationToken cancel = default);
}